import type { ProxySetupOptions, ReverseProxyOption, ReverseProxyOptions, SSLConfig } from './types';

declare const activeServers: Set<http.Server | https.Server>;
declare function cleanup(): void;
declare function loadSSLConfig(options: ReverseProxyOption): Promise<SSLConfig | null>;
declare function isPortInUse(port: number, hostname: string, verbose?: boolean): Promise<boolean>;
declare function findAvailablePort(startPort: number, hostname: string, verbose?: boolean): Promise<number>;
declare function testConnection(hostname: string, port: number, verbose?: boolean): Promise<void>;
export declare function startServer(options?: ReverseProxyOption): Promise<void>;
declare function createProxyServer(from: string, to: string, fromPort: number, listenPort: number, hostname: string, sourceUrl: Pick<URL, 'hostname' | 'host'>, ssl: SSLConfig | null, verbose?: boolean,): Promise<void>;
export declare function setupReverseProxy(options: ProxySetupOptions): Promise<void>;
export declare function startHttpRedirectServer(verbose?: boolean): void;
export declare function startProxy(options?: ReverseProxyOption): void;
export declare function startProxies(options?: ReverseProxyOptions): void;