import type { TlsConfig } from '@stacksjs/tlsx';

export type { TlsConfig };
export declare interface ReverseProxyConfig {
  from: string 
  to: string 
  https: TlsConfig
  verbose: boolean
}
export declare type ReverseProxyOption = Partial<ReverseProxyConfig>
export type ReverseProxyOptions = ReverseProxyOption | ReverseProxyOption[]
export declare interface SSLConfig {
  key: string
  cert: string
  ca?: string | string[]
  secureOptions?: number
}
export declare interface ProxySetupOptions extends Omit<ReverseProxyOption, 'from'> {
  fromPort: number
  sourceUrl: Pick<URL, 'hostname' | 'host'>
  ssl: SSLConfig | null
  from: string
  to: string
}